**************************************************************************
** Nzev programu: RegAPI.PRG
** Verze: 1.0.0
** Datum vytvoen: 2000-01-08
** Popis: Procedury pro prci s Registry
** Autor: Martin Jindra
** E-mail: martin.jindra@egservis.cz
**

#INCLUDE "RegAPI.h"

*******************************************
* Poznmka
*******************************************

* hodnoty se nataj a ukldaj v etzcovm tvaru
* u REG_SZ se mus potat s NULL znakem
* u REG_DWORD se mus potat, e se ukld v binrnm tvaru vyjdenm etzcem
* atd ...

*****************************
* ukzkov procedura
*****************************

* zpis etzcov hodnoty
**************************
*=RegAPIInit()
*LOCAL liHKEY,liOFlag,lcData
*lcData=SPACE(100)
*?API_RegCreateKeyEx(HKEY_CURRENT_USER,"Software\xxx","REG_SZ",@liHKEY,@liOFlag)
*?API_RegSetValueEx(liHKEY,"test",REG_SZ,"ahoj"+CHR(0))
*?API_RegQueryValueEx(liHKEY,"test",REG_SZ,@lcData,100)
*?API_RegCloseKey(liHKEY)

* zpis integeru hodnoty
******************
*=RegAPIInit()
*set proced to kernel
*LOCAL liHKEY,liOFlag,liData
*liData="    "
*?API_RegCreateKeyEx(HKEY_CURRENT_USER,"Software\xxx","REG_SZ",@liHKEY,@liOFlag)
*?API_RegSetValueEx(liHKEY,"test",REG_DWORD,IToC4(100))
*?API_RegQueryValueEx(liHKEY,"test",REG_DWORD,@liData,4)
*?API_RegCloseKey(liHKEY)
*set proced to

* Smazn kle
***********************
*?API_RegDeleteKey(HKEY_CURRENT_USER,"Software\MyApp\Settings")
*?API_RegDeleteKey(HKEY_CURRENT_USER,"Software\MyApp")


***************************************************************************************
* inicializace API funkc
***************************************************************************************
PROCEDURE RegAPIInit
DECLARE INTEGER RegQueryValueEx IN ADVAPI32.DLL;
        INTEGER,STRING @,INTEGER ,INTEGER @,STRING @,INTEGER @

DECLARE INTEGER RegSetValueEx IN ADVAPI32.DLL;
        INTEGER,STRING @,INTEGER,INTEGER,STRING @,INTEGER

DECLARE INTEGER RegCreateKeyEx IN ADVAPI32.DLL;
        INTEGER,STRING @,INTEGER,STRING @,INTEGER,INTEGER,INTEGER,INTEGER @, INTEGER @
        
DECLARE INTEGER RegOpenKeyEx in ADVAPI32.DLL INTEGER, STRING @,INTEGER,INTEGER,INTEGER @nKeyHandle 
DECLARE INTEGER RegCloseKey in ADVAPI32.DLL INTEGER

DECLARE INTEGER RegEnumKeyEx IN ADVAPI32.DLL;
        INTEGER,INTEGER,STRING @,INTEGER @,INTEGER,STRING @,INTEGER @,INTEGER @

DECLARE INTEGER RegDeleteKey IN ADVAPI32.DLL;
        INTEGER, STRING @

DECLARE INTEGER RegDeleteValue IN ADVAPI32.DLL;
        INTEGER, STRING @

DECLARE INTEGER RegEnumValue IN ADVAPI32.DLL;
        INTEGER,INTEGER,STRING @,INTEGER @,INTEGER,INTEGER @,STRING @,INTEGER @


DECLARE INTEGER RegQueryInfoKey IN ADVAPI32.DLL;
  INTEGER, STRING @, INTEGER @, INTEGER, INTEGER @, INTEGER @,;
  INTEGER @, INTEGER @, INTEGER @, INTEGER @, INTEGER @, STRING @

RETURN
ENDPROC
***************************************************************************************
* Oteve dan kl
***************************************************************************************
PROCEDURE API_RegOpenKeyEx(liHRoot,lcKey,liHKEY)
* liHRoot - ID rootu kle nap: HKEY_CURRENT_USER
* lcKey   - Nzev kle (cel cesty) nap: "Software\XXXXX"
*@liHKEY  - Sem se vrt handle kle
LOCAL liErr
liErr=RegOpenKeyEx(liHRoot,@lcKey,0,SECURITY_ACCESS_MASK,@liHKEY)
RETURN IIF(liErr=ERROR_SUCCESS,REGAPI_SUCCESS,REGAPI_Other)
ENDPROC

***************************************************************************************
* Vytvo dan kl
***************************************************************************************
PROCEDURE API_RegCreateKeyEx(liHRoot,lcKey,lcType,liHKEY,liOpenFlag)
* liHRoot    - ID rootu kle nap: HKEY_CURRENT_USER
* lcKey      - Nzev kle (cel cesty) nap: "Software\XXXXX"
* lcType     - Typ ukldanho objektu
*@liHKEY     - Sem se vrt handle kle
*@liOpenFlag - Sem vrt zda kl zaloil, mebo otevel

LOCAL liErr
liErr=RegCreateKeyEx(liHRoot,@lcKey,0,@lcType,0,SECURITY_ACCESS_MASK,0,@liHKEY,@liOpenFlag)
RETURN IIF(liErr=ERROR_SUCCESS,REGAPI_SUCCESS,REGAPI_Other)
ENDPROC


***************************************************************************************
* uzave kl
***************************************************************************************
PROCEDURE API_RegCloseKey(liHKEY)
* liHKEY - Handle kle
LOCAL liErr
liErr=RegCloseKey(liHKEY)
RETURN IIF(liErr=ERROR_SUCCESS,REGAPI_SUCCESS,REGAPI_Other)
ENDPROC


***************************************************************************************
* Zape hodnotu do kle
***************************************************************************************
PROCEDURE API_RegSetValueEx(liHKEY,lcValue,liType,lcData)
* liHKEY  - Handle kle
* lcValue - Nzev hodnoty
* liType  - Typ hodnoty
* lcData  - Data hodnoty

LOCAL liErr,liReserved,liData
liReserved=0
liData=LEN(lcData)

liErr=RegSetValueEx(liHKEY,@lcValue,liReserved,liType,@lcData,liData)
RETURN IIF(liErr=ERROR_SUCCESS,REGAPI_SUCCESS,REGAPI_Other)
ENDPROC

***************************************************************************************
* Nate hodnotu z kle
***************************************************************************************
PROCEDURE API_RegQueryValueEx(liHKEY,lcValue,liType,lcData,liData)
* liHKEY  - Handle kle
* lcValue - Nzev hodnoty
* liType  - Typ hodnoty
*@lcData  - Sem se nacpou data hodnoty
* liData  - Velikost bufferu na data

LOCAL liErr,liReserved
liReserved=0
liErr=RegQueryValueEx(liHKEY,@lcValue,liReserved,@liType,@lcData,@liData)
lcData=LEFT(lcData,liData) && oe data
RETURN IIF(liErr=ERROR_SUCCESS,REGAPI_SUCCESS,liErr)
ENDPROC

***************************************************************************************
* Smae kl
***************************************************************************************
PROCEDURE API_RegDeleteKey(liHKEY,lcKey)
* liHKEY - Handle kle
* lcKey  - Nzev subkle nap: "XXXXX"
LOCAL liErr
liErr=RegDeleteKey(liHKEY,@lcKey)
RETURN IIF(liErr=ERROR_SUCCESS,REGAPI_SUCCESS,REGAPI_Other)
ENDPROC

***************************************************************************************
* Smae hodnotu
***************************************************************************************
PROCEDURE API_RegDeleteValue(liHKEY,lcValue)
* liHKEY  - Handle kle
* lcValue - Nzev hodnoty (cel cesty) nap: "Software\XXXXX\hdonota1"
LOCAL liErr
liErr=RegDeleteValue(liHKEY,@lcValue)
RETURN IIF(liErr=ERROR_SUCCESS,REGAPI_SUCCESS,REGAPI_Other)
ENDPROC


***************************************************************************************
* Vrt kl v poad v otevenm nebo standardnm kli
***************************************************************************************
PROCEDURE API_RegEnumKeyEx(liHKEY,liIndex,lcKey,lcClass,liTime)
* liHKEY  - Handle kle
* liIndex - Poadov index kle
*@lcKey   - Sem se vrt nzev kle
* lcClass - Omezen na tdu kle
*@liTime  - as zpisu ??

LOCAL liErr,liKey,liClass

lcClass=ALLT(lcClass)+CHR(0)
liClass=LEN(lcClass)
liKey=LEN(lcKey)

liErr=RegEnumKeyEx(liHKEY,liIndex,@lcKey,@liKey,0,@lcClass,@liClass,@liTime)
RETURN liErr
ENDPROC


***************************************************************************************
* Vrt hodnoty v poad v otevenm nebo standardnm kli
***************************************************************************************
PROCEDURE API_RegEnumValue(liHKEY,liIndex,lcValue,liType,lcData)
* liHKEY  - Handle kle
* liIndex - Poadov index hodnoty
*@lcValue - Sem se vrt nzev kle
*@liType  - Typ natan hodnoty
*@lcData  - Data hodnoty

LOCAL liErr,liValue,liData

liValue=LEN(lcValue)
* nechce vrtit data
IF PCOUNT()<5 && pokud nechce vrtit obsah hodnoty
   IF PCOUNT()<4 && pokud nechce vrtit typ hodnoty
      liErr=RegEnumValue(liHKEY,liIndex,@lcValue,@liValue,0,0,0,0)
   ELSE
      liErr=RegEnumValue(liHKEY,liIndex,@lcValue,@liValue,0,@liType,0,0)
   ENDIF
   lcValue=LEFT(lcValue,liValue) && oe nzev hodnoty
ELSE
   liData=LEN(lcData)
   liErr=RegEnumValue(liHKEY,liIndex,@lcValue,@liValue,0,@liType,@lcData,@liData)
   lcData=LEFT(lcData,liData) && oe data
ENDIF
RETURN liErr
ENDPROC


***************************************************************************************
* Vrt informace o otevenm kli
***************************************************************************************
PROCEDURE API_RegQueryInfoKey(liHKEY,lcClass,liSubKeys,liMaxSubKeyLen,liMaxClassLen,;
 liValues,liMaxValueNameLen,liMaxValueLen,liSecurityDescriptor,lcDT)
* liHKEY               - Handle kle
* lcClass              - class buffer
* liSubKeys            - number of subkeys
* liMaxSubKeyLen       - longest subkey name
* liMaxClassLen        - longest class string
* liValues             -  number of value entries
* liMaxValueNameLen    - longest value name
* liMaxValueLen        - longest value data
* liSecurityDescriptor - descriptor length
* lcDT                 - last write time

LOCAL liErr,liClass,liReserved

liClass=LEN(lcClass)
liReserved=0
lcDT=REPL(CHR(0),16)

liErr=RegQueryInfoKey(liHKEY,@lcClass,@liClass,liReserved,@liSubKeys,@liMaxSubKeyLen,;
      @liMaxClassLen,@liValues,@liMaxValueNameLen,@liMaxValueLen,@liSecurityDescriptor,@lcDT)
RETURN IIF(liErr=ERROR_SUCCESS,REGAPI_SUCCESS,REGAPI_Other)

ENDPROC
